// Generated by the protocol buffer compiler.  DO NOT EDIT!
// source: commonmodule/commonmodule.proto

package openfmb.commonmodule;

/**
 * <pre>
 * MISSING DOCUMENTATION!!!
 * </pre>
 *
 * Protobuf type {@code commonmodule.VoltWCSG}
 */
public final class VoltWCSG extends
    com.google.protobuf.GeneratedMessageV3 implements
    // @@protoc_insertion_point(message_implements:commonmodule.VoltWCSG)
    VoltWCSGOrBuilder {
private static final long serialVersionUID = 0L;
  // Use VoltWCSG.newBuilder() to construct.
  private VoltWCSG(com.google.protobuf.GeneratedMessageV3.Builder<?> builder) {
    super(builder);
  }
  private VoltWCSG() {
    crvPts_ = java.util.Collections.emptyList();
  }

  @java.lang.Override
  @SuppressWarnings({"unused"})
  protected java.lang.Object newInstance(
      UnusedPrivateParameter unused) {
    return new VoltWCSG();
  }

  public static final com.google.protobuf.Descriptors.Descriptor
      getDescriptor() {
    return openfmb.commonmodule.Commonmodule.internal_static_commonmodule_VoltWCSG_descriptor;
  }

  @java.lang.Override
  protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
      internalGetFieldAccessorTable() {
    return openfmb.commonmodule.Commonmodule.internal_static_commonmodule_VoltWCSG_fieldAccessorTable
        .ensureFieldAccessorsInitialized(
            openfmb.commonmodule.VoltWCSG.class, openfmb.commonmodule.VoltWCSG.Builder.class);
  }

  public static final int CRVPTS_FIELD_NUMBER = 1;
  @SuppressWarnings("serial")
  private java.util.List<openfmb.commonmodule.VoltWPoint> crvPts_;
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>repeated .commonmodule.VoltWPoint crvPts = 1 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
   */
  @java.lang.Override
  public java.util.List<openfmb.commonmodule.VoltWPoint> getCrvPtsList() {
    return crvPts_;
  }
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>repeated .commonmodule.VoltWPoint crvPts = 1 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
   */
  @java.lang.Override
  public java.util.List<? extends openfmb.commonmodule.VoltWPointOrBuilder> 
      getCrvPtsOrBuilderList() {
    return crvPts_;
  }
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>repeated .commonmodule.VoltWPoint crvPts = 1 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
   */
  @java.lang.Override
  public int getCrvPtsCount() {
    return crvPts_.size();
  }
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>repeated .commonmodule.VoltWPoint crvPts = 1 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
   */
  @java.lang.Override
  public openfmb.commonmodule.VoltWPoint getCrvPts(int index) {
    return crvPts_.get(index);
  }
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>repeated .commonmodule.VoltWPoint crvPts = 1 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
   */
  @java.lang.Override
  public openfmb.commonmodule.VoltWPointOrBuilder getCrvPtsOrBuilder(
      int index) {
    return crvPts_.get(index);
  }

  public static final int VOLTWPARAMETER_FIELD_NUMBER = 2;
  private openfmb.commonmodule.OperationDVWC voltWParameter_;
  /**
   * <pre>
   * Voltage-Active Power (Volt-Watt) Function
   * </pre>
   *
   * <code>.commonmodule.OperationDVWC voltWParameter = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
   * @return Whether the voltWParameter field is set.
   */
  @java.lang.Override
  public boolean hasVoltWParameter() {
    return voltWParameter_ != null;
  }
  /**
   * <pre>
   * Voltage-Active Power (Volt-Watt) Function
   * </pre>
   *
   * <code>.commonmodule.OperationDVWC voltWParameter = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
   * @return The voltWParameter.
   */
  @java.lang.Override
  public openfmb.commonmodule.OperationDVWC getVoltWParameter() {
    return voltWParameter_ == null ? openfmb.commonmodule.OperationDVWC.getDefaultInstance() : voltWParameter_;
  }
  /**
   * <pre>
   * Voltage-Active Power (Volt-Watt) Function
   * </pre>
   *
   * <code>.commonmodule.OperationDVWC voltWParameter = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
   */
  @java.lang.Override
  public openfmb.commonmodule.OperationDVWCOrBuilder getVoltWParameterOrBuilder() {
    return voltWParameter_ == null ? openfmb.commonmodule.OperationDVWC.getDefaultInstance() : voltWParameter_;
  }

  private byte memoizedIsInitialized = -1;
  @java.lang.Override
  public final boolean isInitialized() {
    byte isInitialized = memoizedIsInitialized;
    if (isInitialized == 1) return true;
    if (isInitialized == 0) return false;

    memoizedIsInitialized = 1;
    return true;
  }

  @java.lang.Override
  public void writeTo(com.google.protobuf.CodedOutputStream output)
                      throws java.io.IOException {
    for (int i = 0; i < crvPts_.size(); i++) {
      output.writeMessage(1, crvPts_.get(i));
    }
    if (voltWParameter_ != null) {
      output.writeMessage(2, getVoltWParameter());
    }
    getUnknownFields().writeTo(output);
  }

  @java.lang.Override
  public int getSerializedSize() {
    int size = memoizedSize;
    if (size != -1) return size;

    size = 0;
    for (int i = 0; i < crvPts_.size(); i++) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(1, crvPts_.get(i));
    }
    if (voltWParameter_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(2, getVoltWParameter());
    }
    size += getUnknownFields().getSerializedSize();
    memoizedSize = size;
    return size;
  }

  @java.lang.Override
  public boolean equals(final java.lang.Object obj) {
    if (obj == this) {
     return true;
    }
    if (!(obj instanceof openfmb.commonmodule.VoltWCSG)) {
      return super.equals(obj);
    }
    openfmb.commonmodule.VoltWCSG other = (openfmb.commonmodule.VoltWCSG) obj;

    if (!getCrvPtsList()
        .equals(other.getCrvPtsList())) return false;
    if (hasVoltWParameter() != other.hasVoltWParameter()) return false;
    if (hasVoltWParameter()) {
      if (!getVoltWParameter()
          .equals(other.getVoltWParameter())) return false;
    }
    if (!getUnknownFields().equals(other.getUnknownFields())) return false;
    return true;
  }

  @java.lang.Override
  public int hashCode() {
    if (memoizedHashCode != 0) {
      return memoizedHashCode;
    }
    int hash = 41;
    hash = (19 * hash) + getDescriptor().hashCode();
    if (getCrvPtsCount() > 0) {
      hash = (37 * hash) + CRVPTS_FIELD_NUMBER;
      hash = (53 * hash) + getCrvPtsList().hashCode();
    }
    if (hasVoltWParameter()) {
      hash = (37 * hash) + VOLTWPARAMETER_FIELD_NUMBER;
      hash = (53 * hash) + getVoltWParameter().hashCode();
    }
    hash = (29 * hash) + getUnknownFields().hashCode();
    memoizedHashCode = hash;
    return hash;
  }

  public static openfmb.commonmodule.VoltWCSG parseFrom(
      java.nio.ByteBuffer data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static openfmb.commonmodule.VoltWCSG parseFrom(
      java.nio.ByteBuffer data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static openfmb.commonmodule.VoltWCSG parseFrom(
      com.google.protobuf.ByteString data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static openfmb.commonmodule.VoltWCSG parseFrom(
      com.google.protobuf.ByteString data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static openfmb.commonmodule.VoltWCSG parseFrom(byte[] data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static openfmb.commonmodule.VoltWCSG parseFrom(
      byte[] data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static openfmb.commonmodule.VoltWCSG parseFrom(java.io.InputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input);
  }
  public static openfmb.commonmodule.VoltWCSG parseFrom(
      java.io.InputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input, extensionRegistry);
  }
  public static openfmb.commonmodule.VoltWCSG parseDelimitedFrom(java.io.InputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseDelimitedWithIOException(PARSER, input);
  }
  public static openfmb.commonmodule.VoltWCSG parseDelimitedFrom(
      java.io.InputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseDelimitedWithIOException(PARSER, input, extensionRegistry);
  }
  public static openfmb.commonmodule.VoltWCSG parseFrom(
      com.google.protobuf.CodedInputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input);
  }
  public static openfmb.commonmodule.VoltWCSG parseFrom(
      com.google.protobuf.CodedInputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input, extensionRegistry);
  }

  @java.lang.Override
  public Builder newBuilderForType() { return newBuilder(); }
  public static Builder newBuilder() {
    return DEFAULT_INSTANCE.toBuilder();
  }
  public static Builder newBuilder(openfmb.commonmodule.VoltWCSG prototype) {
    return DEFAULT_INSTANCE.toBuilder().mergeFrom(prototype);
  }
  @java.lang.Override
  public Builder toBuilder() {
    return this == DEFAULT_INSTANCE
        ? new Builder() : new Builder().mergeFrom(this);
  }

  @java.lang.Override
  protected Builder newBuilderForType(
      com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
    Builder builder = new Builder(parent);
    return builder;
  }
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * Protobuf type {@code commonmodule.VoltWCSG}
   */
  public static final class Builder extends
      com.google.protobuf.GeneratedMessageV3.Builder<Builder> implements
      // @@protoc_insertion_point(builder_implements:commonmodule.VoltWCSG)
      openfmb.commonmodule.VoltWCSGOrBuilder {
    public static final com.google.protobuf.Descriptors.Descriptor
        getDescriptor() {
      return openfmb.commonmodule.Commonmodule.internal_static_commonmodule_VoltWCSG_descriptor;
    }

    @java.lang.Override
    protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return openfmb.commonmodule.Commonmodule.internal_static_commonmodule_VoltWCSG_fieldAccessorTable
          .ensureFieldAccessorsInitialized(
              openfmb.commonmodule.VoltWCSG.class, openfmb.commonmodule.VoltWCSG.Builder.class);
    }

    // Construct using openfmb.commonmodule.VoltWCSG.newBuilder()
    private Builder() {

    }

    private Builder(
        com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
      super(parent);

    }
    @java.lang.Override
    public Builder clear() {
      super.clear();
      bitField0_ = 0;
      if (crvPtsBuilder_ == null) {
        crvPts_ = java.util.Collections.emptyList();
      } else {
        crvPts_ = null;
        crvPtsBuilder_.clear();
      }
      bitField0_ = (bitField0_ & ~0x00000001);
      voltWParameter_ = null;
      if (voltWParameterBuilder_ != null) {
        voltWParameterBuilder_.dispose();
        voltWParameterBuilder_ = null;
      }
      return this;
    }

    @java.lang.Override
    public com.google.protobuf.Descriptors.Descriptor
        getDescriptorForType() {
      return openfmb.commonmodule.Commonmodule.internal_static_commonmodule_VoltWCSG_descriptor;
    }

    @java.lang.Override
    public openfmb.commonmodule.VoltWCSG getDefaultInstanceForType() {
      return openfmb.commonmodule.VoltWCSG.getDefaultInstance();
    }

    @java.lang.Override
    public openfmb.commonmodule.VoltWCSG build() {
      openfmb.commonmodule.VoltWCSG result = buildPartial();
      if (!result.isInitialized()) {
        throw newUninitializedMessageException(result);
      }
      return result;
    }

    @java.lang.Override
    public openfmb.commonmodule.VoltWCSG buildPartial() {
      openfmb.commonmodule.VoltWCSG result = new openfmb.commonmodule.VoltWCSG(this);
      buildPartialRepeatedFields(result);
      if (bitField0_ != 0) { buildPartial0(result); }
      onBuilt();
      return result;
    }

    private void buildPartialRepeatedFields(openfmb.commonmodule.VoltWCSG result) {
      if (crvPtsBuilder_ == null) {
        if (((bitField0_ & 0x00000001) != 0)) {
          crvPts_ = java.util.Collections.unmodifiableList(crvPts_);
          bitField0_ = (bitField0_ & ~0x00000001);
        }
        result.crvPts_ = crvPts_;
      } else {
        result.crvPts_ = crvPtsBuilder_.build();
      }
    }

    private void buildPartial0(openfmb.commonmodule.VoltWCSG result) {
      int from_bitField0_ = bitField0_;
      if (((from_bitField0_ & 0x00000002) != 0)) {
        result.voltWParameter_ = voltWParameterBuilder_ == null
            ? voltWParameter_
            : voltWParameterBuilder_.build();
      }
    }

    @java.lang.Override
    public Builder mergeFrom(com.google.protobuf.Message other) {
      if (other instanceof openfmb.commonmodule.VoltWCSG) {
        return mergeFrom((openfmb.commonmodule.VoltWCSG)other);
      } else {
        super.mergeFrom(other);
        return this;
      }
    }

    public Builder mergeFrom(openfmb.commonmodule.VoltWCSG other) {
      if (other == openfmb.commonmodule.VoltWCSG.getDefaultInstance()) return this;
      if (crvPtsBuilder_ == null) {
        if (!other.crvPts_.isEmpty()) {
          if (crvPts_.isEmpty()) {
            crvPts_ = other.crvPts_;
            bitField0_ = (bitField0_ & ~0x00000001);
          } else {
            ensureCrvPtsIsMutable();
            crvPts_.addAll(other.crvPts_);
          }
          onChanged();
        }
      } else {
        if (!other.crvPts_.isEmpty()) {
          if (crvPtsBuilder_.isEmpty()) {
            crvPtsBuilder_.dispose();
            crvPtsBuilder_ = null;
            crvPts_ = other.crvPts_;
            bitField0_ = (bitField0_ & ~0x00000001);
            crvPtsBuilder_ = 
              com.google.protobuf.GeneratedMessageV3.alwaysUseFieldBuilders ?
                 getCrvPtsFieldBuilder() : null;
          } else {
            crvPtsBuilder_.addAllMessages(other.crvPts_);
          }
        }
      }
      if (other.hasVoltWParameter()) {
        mergeVoltWParameter(other.getVoltWParameter());
      }
      this.mergeUnknownFields(other.getUnknownFields());
      onChanged();
      return this;
    }

    @java.lang.Override
    public final boolean isInitialized() {
      return true;
    }

    @java.lang.Override
    public Builder mergeFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      if (extensionRegistry == null) {
        throw new java.lang.NullPointerException();
      }
      try {
        boolean done = false;
        while (!done) {
          int tag = input.readTag();
          switch (tag) {
            case 0:
              done = true;
              break;
            case 10: {
              openfmb.commonmodule.VoltWPoint m =
                  input.readMessage(
                      openfmb.commonmodule.VoltWPoint.parser(),
                      extensionRegistry);
              if (crvPtsBuilder_ == null) {
                ensureCrvPtsIsMutable();
                crvPts_.add(m);
              } else {
                crvPtsBuilder_.addMessage(m);
              }
              break;
            } // case 10
            case 18: {
              input.readMessage(
                  getVoltWParameterFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000002;
              break;
            } // case 18
            default: {
              if (!super.parseUnknownField(input, extensionRegistry, tag)) {
                done = true; // was an endgroup tag
              }
              break;
            } // default:
          } // switch (tag)
        } // while (!done)
      } catch (com.google.protobuf.InvalidProtocolBufferException e) {
        throw e.unwrapIOException();
      } finally {
        onChanged();
      } // finally
      return this;
    }
    private int bitField0_;

    private java.util.List<openfmb.commonmodule.VoltWPoint> crvPts_ =
      java.util.Collections.emptyList();
    private void ensureCrvPtsIsMutable() {
      if (!((bitField0_ & 0x00000001) != 0)) {
        crvPts_ = new java.util.ArrayList<openfmb.commonmodule.VoltWPoint>(crvPts_);
        bitField0_ |= 0x00000001;
       }
    }

    private com.google.protobuf.RepeatedFieldBuilderV3<
        openfmb.commonmodule.VoltWPoint, openfmb.commonmodule.VoltWPoint.Builder, openfmb.commonmodule.VoltWPointOrBuilder> crvPtsBuilder_;

    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>repeated .commonmodule.VoltWPoint crvPts = 1 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public java.util.List<openfmb.commonmodule.VoltWPoint> getCrvPtsList() {
      if (crvPtsBuilder_ == null) {
        return java.util.Collections.unmodifiableList(crvPts_);
      } else {
        return crvPtsBuilder_.getMessageList();
      }
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>repeated .commonmodule.VoltWPoint crvPts = 1 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public int getCrvPtsCount() {
      if (crvPtsBuilder_ == null) {
        return crvPts_.size();
      } else {
        return crvPtsBuilder_.getCount();
      }
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>repeated .commonmodule.VoltWPoint crvPts = 1 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public openfmb.commonmodule.VoltWPoint getCrvPts(int index) {
      if (crvPtsBuilder_ == null) {
        return crvPts_.get(index);
      } else {
        return crvPtsBuilder_.getMessage(index);
      }
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>repeated .commonmodule.VoltWPoint crvPts = 1 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public Builder setCrvPts(
        int index, openfmb.commonmodule.VoltWPoint value) {
      if (crvPtsBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        ensureCrvPtsIsMutable();
        crvPts_.set(index, value);
        onChanged();
      } else {
        crvPtsBuilder_.setMessage(index, value);
      }
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>repeated .commonmodule.VoltWPoint crvPts = 1 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public Builder setCrvPts(
        int index, openfmb.commonmodule.VoltWPoint.Builder builderForValue) {
      if (crvPtsBuilder_ == null) {
        ensureCrvPtsIsMutable();
        crvPts_.set(index, builderForValue.build());
        onChanged();
      } else {
        crvPtsBuilder_.setMessage(index, builderForValue.build());
      }
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>repeated .commonmodule.VoltWPoint crvPts = 1 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public Builder addCrvPts(openfmb.commonmodule.VoltWPoint value) {
      if (crvPtsBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        ensureCrvPtsIsMutable();
        crvPts_.add(value);
        onChanged();
      } else {
        crvPtsBuilder_.addMessage(value);
      }
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>repeated .commonmodule.VoltWPoint crvPts = 1 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public Builder addCrvPts(
        int index, openfmb.commonmodule.VoltWPoint value) {
      if (crvPtsBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        ensureCrvPtsIsMutable();
        crvPts_.add(index, value);
        onChanged();
      } else {
        crvPtsBuilder_.addMessage(index, value);
      }
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>repeated .commonmodule.VoltWPoint crvPts = 1 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public Builder addCrvPts(
        openfmb.commonmodule.VoltWPoint.Builder builderForValue) {
      if (crvPtsBuilder_ == null) {
        ensureCrvPtsIsMutable();
        crvPts_.add(builderForValue.build());
        onChanged();
      } else {
        crvPtsBuilder_.addMessage(builderForValue.build());
      }
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>repeated .commonmodule.VoltWPoint crvPts = 1 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public Builder addCrvPts(
        int index, openfmb.commonmodule.VoltWPoint.Builder builderForValue) {
      if (crvPtsBuilder_ == null) {
        ensureCrvPtsIsMutable();
        crvPts_.add(index, builderForValue.build());
        onChanged();
      } else {
        crvPtsBuilder_.addMessage(index, builderForValue.build());
      }
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>repeated .commonmodule.VoltWPoint crvPts = 1 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public Builder addAllCrvPts(
        java.lang.Iterable<? extends openfmb.commonmodule.VoltWPoint> values) {
      if (crvPtsBuilder_ == null) {
        ensureCrvPtsIsMutable();
        com.google.protobuf.AbstractMessageLite.Builder.addAll(
            values, crvPts_);
        onChanged();
      } else {
        crvPtsBuilder_.addAllMessages(values);
      }
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>repeated .commonmodule.VoltWPoint crvPts = 1 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public Builder clearCrvPts() {
      if (crvPtsBuilder_ == null) {
        crvPts_ = java.util.Collections.emptyList();
        bitField0_ = (bitField0_ & ~0x00000001);
        onChanged();
      } else {
        crvPtsBuilder_.clear();
      }
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>repeated .commonmodule.VoltWPoint crvPts = 1 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public Builder removeCrvPts(int index) {
      if (crvPtsBuilder_ == null) {
        ensureCrvPtsIsMutable();
        crvPts_.remove(index);
        onChanged();
      } else {
        crvPtsBuilder_.remove(index);
      }
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>repeated .commonmodule.VoltWPoint crvPts = 1 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public openfmb.commonmodule.VoltWPoint.Builder getCrvPtsBuilder(
        int index) {
      return getCrvPtsFieldBuilder().getBuilder(index);
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>repeated .commonmodule.VoltWPoint crvPts = 1 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public openfmb.commonmodule.VoltWPointOrBuilder getCrvPtsOrBuilder(
        int index) {
      if (crvPtsBuilder_ == null) {
        return crvPts_.get(index);  } else {
        return crvPtsBuilder_.getMessageOrBuilder(index);
      }
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>repeated .commonmodule.VoltWPoint crvPts = 1 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public java.util.List<? extends openfmb.commonmodule.VoltWPointOrBuilder> 
         getCrvPtsOrBuilderList() {
      if (crvPtsBuilder_ != null) {
        return crvPtsBuilder_.getMessageOrBuilderList();
      } else {
        return java.util.Collections.unmodifiableList(crvPts_);
      }
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>repeated .commonmodule.VoltWPoint crvPts = 1 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public openfmb.commonmodule.VoltWPoint.Builder addCrvPtsBuilder() {
      return getCrvPtsFieldBuilder().addBuilder(
          openfmb.commonmodule.VoltWPoint.getDefaultInstance());
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>repeated .commonmodule.VoltWPoint crvPts = 1 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public openfmb.commonmodule.VoltWPoint.Builder addCrvPtsBuilder(
        int index) {
      return getCrvPtsFieldBuilder().addBuilder(
          index, openfmb.commonmodule.VoltWPoint.getDefaultInstance());
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>repeated .commonmodule.VoltWPoint crvPts = 1 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public java.util.List<openfmb.commonmodule.VoltWPoint.Builder> 
         getCrvPtsBuilderList() {
      return getCrvPtsFieldBuilder().getBuilderList();
    }
    private com.google.protobuf.RepeatedFieldBuilderV3<
        openfmb.commonmodule.VoltWPoint, openfmb.commonmodule.VoltWPoint.Builder, openfmb.commonmodule.VoltWPointOrBuilder> 
        getCrvPtsFieldBuilder() {
      if (crvPtsBuilder_ == null) {
        crvPtsBuilder_ = new com.google.protobuf.RepeatedFieldBuilderV3<
            openfmb.commonmodule.VoltWPoint, openfmb.commonmodule.VoltWPoint.Builder, openfmb.commonmodule.VoltWPointOrBuilder>(
                crvPts_,
                ((bitField0_ & 0x00000001) != 0),
                getParentForChildren(),
                isClean());
        crvPts_ = null;
      }
      return crvPtsBuilder_;
    }

    private openfmb.commonmodule.OperationDVWC voltWParameter_;
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.OperationDVWC, openfmb.commonmodule.OperationDVWC.Builder, openfmb.commonmodule.OperationDVWCOrBuilder> voltWParameterBuilder_;
    /**
     * <pre>
     * Voltage-Active Power (Volt-Watt) Function
     * </pre>
     *
     * <code>.commonmodule.OperationDVWC voltWParameter = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     * @return Whether the voltWParameter field is set.
     */
    public boolean hasVoltWParameter() {
      return ((bitField0_ & 0x00000002) != 0);
    }
    /**
     * <pre>
     * Voltage-Active Power (Volt-Watt) Function
     * </pre>
     *
     * <code>.commonmodule.OperationDVWC voltWParameter = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     * @return The voltWParameter.
     */
    public openfmb.commonmodule.OperationDVWC getVoltWParameter() {
      if (voltWParameterBuilder_ == null) {
        return voltWParameter_ == null ? openfmb.commonmodule.OperationDVWC.getDefaultInstance() : voltWParameter_;
      } else {
        return voltWParameterBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * Voltage-Active Power (Volt-Watt) Function
     * </pre>
     *
     * <code>.commonmodule.OperationDVWC voltWParameter = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public Builder setVoltWParameter(openfmb.commonmodule.OperationDVWC value) {
      if (voltWParameterBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        voltWParameter_ = value;
      } else {
        voltWParameterBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000002;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Voltage-Active Power (Volt-Watt) Function
     * </pre>
     *
     * <code>.commonmodule.OperationDVWC voltWParameter = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public Builder setVoltWParameter(
        openfmb.commonmodule.OperationDVWC.Builder builderForValue) {
      if (voltWParameterBuilder_ == null) {
        voltWParameter_ = builderForValue.build();
      } else {
        voltWParameterBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000002;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Voltage-Active Power (Volt-Watt) Function
     * </pre>
     *
     * <code>.commonmodule.OperationDVWC voltWParameter = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public Builder mergeVoltWParameter(openfmb.commonmodule.OperationDVWC value) {
      if (voltWParameterBuilder_ == null) {
        if (((bitField0_ & 0x00000002) != 0) &&
          voltWParameter_ != null &&
          voltWParameter_ != openfmb.commonmodule.OperationDVWC.getDefaultInstance()) {
          getVoltWParameterBuilder().mergeFrom(value);
        } else {
          voltWParameter_ = value;
        }
      } else {
        voltWParameterBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000002;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Voltage-Active Power (Volt-Watt) Function
     * </pre>
     *
     * <code>.commonmodule.OperationDVWC voltWParameter = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public Builder clearVoltWParameter() {
      bitField0_ = (bitField0_ & ~0x00000002);
      voltWParameter_ = null;
      if (voltWParameterBuilder_ != null) {
        voltWParameterBuilder_.dispose();
        voltWParameterBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Voltage-Active Power (Volt-Watt) Function
     * </pre>
     *
     * <code>.commonmodule.OperationDVWC voltWParameter = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public openfmb.commonmodule.OperationDVWC.Builder getVoltWParameterBuilder() {
      bitField0_ |= 0x00000002;
      onChanged();
      return getVoltWParameterFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * Voltage-Active Power (Volt-Watt) Function
     * </pre>
     *
     * <code>.commonmodule.OperationDVWC voltWParameter = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public openfmb.commonmodule.OperationDVWCOrBuilder getVoltWParameterOrBuilder() {
      if (voltWParameterBuilder_ != null) {
        return voltWParameterBuilder_.getMessageOrBuilder();
      } else {
        return voltWParameter_ == null ?
            openfmb.commonmodule.OperationDVWC.getDefaultInstance() : voltWParameter_;
      }
    }
    /**
     * <pre>
     * Voltage-Active Power (Volt-Watt) Function
     * </pre>
     *
     * <code>.commonmodule.OperationDVWC voltWParameter = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.OperationDVWC, openfmb.commonmodule.OperationDVWC.Builder, openfmb.commonmodule.OperationDVWCOrBuilder> 
        getVoltWParameterFieldBuilder() {
      if (voltWParameterBuilder_ == null) {
        voltWParameterBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            openfmb.commonmodule.OperationDVWC, openfmb.commonmodule.OperationDVWC.Builder, openfmb.commonmodule.OperationDVWCOrBuilder>(
                getVoltWParameter(),
                getParentForChildren(),
                isClean());
        voltWParameter_ = null;
      }
      return voltWParameterBuilder_;
    }
    @java.lang.Override
    public final Builder setUnknownFields(
        final com.google.protobuf.UnknownFieldSet unknownFields) {
      return super.setUnknownFields(unknownFields);
    }

    @java.lang.Override
    public final Builder mergeUnknownFields(
        final com.google.protobuf.UnknownFieldSet unknownFields) {
      return super.mergeUnknownFields(unknownFields);
    }


    // @@protoc_insertion_point(builder_scope:commonmodule.VoltWCSG)
  }

  // @@protoc_insertion_point(class_scope:commonmodule.VoltWCSG)
  private static final openfmb.commonmodule.VoltWCSG DEFAULT_INSTANCE;
  static {
    DEFAULT_INSTANCE = new openfmb.commonmodule.VoltWCSG();
  }

  public static openfmb.commonmodule.VoltWCSG getDefaultInstance() {
    return DEFAULT_INSTANCE;
  }

  private static final com.google.protobuf.Parser<VoltWCSG>
      PARSER = new com.google.protobuf.AbstractParser<VoltWCSG>() {
    @java.lang.Override
    public VoltWCSG parsePartialFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      Builder builder = newBuilder();
      try {
        builder.mergeFrom(input, extensionRegistry);
      } catch (com.google.protobuf.InvalidProtocolBufferException e) {
        throw e.setUnfinishedMessage(builder.buildPartial());
      } catch (com.google.protobuf.UninitializedMessageException e) {
        throw e.asInvalidProtocolBufferException().setUnfinishedMessage(builder.buildPartial());
      } catch (java.io.IOException e) {
        throw new com.google.protobuf.InvalidProtocolBufferException(e)
            .setUnfinishedMessage(builder.buildPartial());
      }
      return builder.buildPartial();
    }
  };

  public static com.google.protobuf.Parser<VoltWCSG> parser() {
    return PARSER;
  }

  @java.lang.Override
  public com.google.protobuf.Parser<VoltWCSG> getParserForType() {
    return PARSER;
  }

  @java.lang.Override
  public openfmb.commonmodule.VoltWCSG getDefaultInstanceForType() {
    return DEFAULT_INSTANCE;
  }

}

